#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "da_bin.h"

static int bin_read(void *fd, void *buff, size_t size)
{
	return read(*(int *)fd, buff, size);
}

int mawk_load_code_bin(mawk_state_t *MAWK, const char *fn)
{
	int ret, fd;

	fd = open(fn, O_RDONLY);
	if (fd < 0)
		return MAWK_ECANTOPEN;

	ret = mawk_load_code_bin_(MAWK, &fd, bin_read);

	close(fd);
	return ret;
}

static int bin_write(void *fd, const void *buff, size_t size)
{
	return write(*(int *)fd, buff, size);
}

int mawk_print_code_bin(mawk_state_t *MAWK, const char *fn)
{
	int ret, fd;

	fd = 1;
	ret = mawk_save_code_bin_(MAWK, &fd, bin_write);
	fsync(1);

	return ret;
}

