#ifndef STDLIB_H
#define STDLIB_H
#include <linux/export.h>
#include <linux/types.h>
#include <linux/slab.h>
#include <linux/gfp.h>

#define NULL ((void *)0)
typedef void * PTR;

#define malloc(size) kmalloc(size, GFP_KERNEL)
#define free(ptr) kfree(ptr)

static inline void *realloc(void *ptr, size_t size)
{
	void *nw;
	nw = malloc(size);
	memcpy(nw, ptr, size);
	free(ptr);
	return nw;
}

#define exit(n)
#define abort(n)

#endif
